// <applet code=TicTac.class width=450 height=300> </applet>

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;

public class TicTac extends Applet implements ImageObserver, MouseListener, ActionListener {

class TicTacCanvas extends Canvas {

	TicTacCanvas() {
	setBackground(Color.white);}

	 public void paint(Graphics g)
	{
		g.drawImage(arbre,0,0,200,2400,null);
		g.setColor(Color.black);
		g.drawString("Arbre de dcision ",50,15);
		g.drawLine(0,20,200,20);
		g.drawLine(0,40,200,40);
		g.drawLine(100,20,100,2400);
		g.drawLine(200,0,200,2400);
		g.drawString("Coup Ordino",15,35);
		g.drawString("Coup joueur",112,35);
	}
}


	Damier d;
	Image arbre;
	ScrollPane dfilement;
	TicTacCanvas le_canvas;
	Button reset;

	public void init()
	{
		resize(410,310);
		setLayout(null);
		d = new Damier(this);
		addMouseListener(this);
		dfilement = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
		dfilement.setSize(220,300) ;
		le_canvas = new TicTacCanvas();
		le_canvas.setSize(200,2400);
		dfilement.add(le_canvas);
		add(dfilement);
		dfilement.setBounds(190,10,220,300);
		dfilement.setLocation(190,10);
		setBackground(Color.white);
		arbre = createImage(200,2400);
		reset = new Button("Relancer");
		reset.addActionListener(this);
		add(reset);
		reset.setSize(100,20);
		reset.setLocation(10,280);
		dfilement.setVisible(true);
		le_canvas.setSize(200,2400);
	}

	public void start() { le_canvas.repaint();}

	public void paint(Graphics g)
	{
		d.dessine(g);
	}

	public void actionPerformed(ActionEvent ev) {
	String label = ev.getActionCommand();

	if (label.equals("Relancer"))
	{
		d = new Damier(this);
		Graphics g;
		g=arbre.getGraphics();
		g.setColor(Color.white);
		g.fillRect(0,0,300,3000);
		le_canvas.repaint();
		repaint();
	}
	}

	public void mouseClicked(MouseEvent e) {
		d.coup(e.getX(),e.getY());
		repaint();
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

	public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height)
	{
		repaint();
		return true;
	}
}

class Damier {

	Pion[] cases;
	int couleur_ordinateur = 1; // Croix
	boolean coup_ordino = false; // a vrai si c'est  l'ordinateur de jouer.
	int niveau = 0;
	int coup = -1;
	Damier[] coups_possibles;
	TicTac parent;

	Damier(Damier pere, int cp)
	{
		coups_possibles= new Damier[0];
		parent = pere.parent;
		cases = new Pion[9];
		coup = cp;
		for (int i=0;i<9;i++) cases[i] = pere.cases[i];
		coup_ordino = ! pere.coup_ordino;
		couleur_ordinateur = pere.couleur_ordinateur;
		niveau = pere.niveau + 1;
		if (coup_ordino)
		{
			if (couleur_ordinateur == 2) cases[coup]=new Croix(coup,parent);
			else cases[coup]=new Rond(coup,parent);
		} else
		{
			if (couleur_ordinateur == 1) cases[coup]=new Croix(coup,parent);
			else cases[coup]=new Rond(coup,parent);
		}
	}

	Damier(TicTac t){
	coups_possibles= new Damier[0];
	parent = t;
	int i =(int)Math.round(Math.random()*100);
	i=2;
	if ((i % 2)==1) {
		couleur_ordinateur = 1;
		coup_ordino = true;
	} else
	{
		couleur_ordinateur = 2; // 1 = croix, 2 = Rond
		coup_ordino = false;
	}
	cases = new Pion[9];
	for (i=0;i<9;i++) cases[i] = new Vide(i);
	if (coup_ordino) coup_ordino();
	}
	public void coup_ordino()
	{
		long meilleure_note = -100000;
		int meilleur_coup = 0;
		if (! coup_ordino) return;
		boolean debut = true;
		for (int i=0;i<9;i++) if (cases[i].code() != 0) debut=false;
		if (debut)
		{
			int alea =(int)Math.round(Math.random()*100);
			alea = alea % 9;
			if (couleur_ordinateur == 1) cases[alea]=new Croix(alea,parent);
			else cases[alea]=new Rond(alea,parent);
		}
		else
		{
			cherche_coup();
			Graphics g;
			g=parent.arbre.getGraphics();
			g.setColor(Color.white);
			g.fillRect(0,0,300,3000);
			dessine_minmax(parent.arbre.getGraphics(),0);
			parent.le_canvas.repaint();
			if (coups_possibles.length>0)
			{
				Damier d = coups_possibles[0];
				meilleure_note = d.total_note();
				meilleur_coup = d.coup;
				for (int i =0;i<coups_possibles.length;i++)
				{
					d = coups_possibles[i];
					long n = d.total_note();
					if (meilleure_note < n)
					{
						meilleure_note =n;
						meilleur_coup = d.coup;
					}
				}
				if (couleur_ordinateur == 1) cases[meilleur_coup]=new Croix(meilleur_coup,parent);
				else cases[meilleur_coup]=new Rond(meilleur_coup,parent);
			}
		}
		coup_ordino=false;
		parent.repaint();
		parent.le_canvas.repaint();
	}
	public boolean termine()
	{
		int i = 0;
		boolean ret = true;
		for (i=0;i<9;i++) if (cases[i].code()==0) ret=false;
		if (cases[0].code() != 0)
		{
			if ((cases[0].code() == cases[1].code()) &&
			(cases[1].code() == cases[2].code())) ret = true;
			if ((cases[0].code() == cases[3].code()) &&
			(cases[3].code() == cases[6].code())) ret = true;
			if ((cases[0].code() == cases[4].code()) &&
			(cases[4].code() == cases[8].code())) ret = true;
		}
		if (cases[1].code() != 0)
		{
			if ((cases[1].code() == cases[4].code()) &&
			(cases[4].code() == cases[7].code())) ret = true;
		}
		if (cases[2].code() != 0)
		{
			if ((cases[2].code() == cases[5].code()) &&
			(cases[5].code() == cases[8].code())) ret = true;
		}
		if (cases[3].code() != 0)
		{
			if ((cases[3].code() == cases[4].code()) &&
			(cases[4].code() == cases[5].code())) ret = true;
		}
		if (cases[6].code() != 0)
		{
			if ((cases[6].code() == cases[7].code()) &&
			(cases[7].code() == cases[8].code())) ret = true;
			if ((cases[6].code() == cases[4].code()) &&
			(cases[4].code() == cases[2].code())) ret = true;
		}
		return ret;
	}
	public void coup(int x, int y)
	{
		if ((! coup_ordino) && (! termine()))
		for (int i = 0;i<9;i++)
		{
			if (cases[i].coup(x,y))
			{
				if (couleur_ordinateur == 1) cases[i]=new Rond(i,parent);
				else cases[i]=new Croix(i,parent);
				coup_ordino = true;
				parent.repaint();
				parent.le_canvas.repaint();
				coup_ordino();
			}
		}
	}

	private int nb_couleur(int a, int b, int c,int coul)
	{
		int nb = 0;
		if (cases[a].code()==coul) nb ++;
		if (cases[b].code()==coul) nb ++;
		if (cases[c].code()==coul) nb ++;
		return nb;
	}

	public int combinaison(int a, int b, int c)
	{
		int coul = 0;
		int nb_coul = 0;int nb_vide;
		int nb = 0;
		if ( coup_ordino)
		{
			if (couleur_ordinateur == 1) coul = 2; else coul=1;
		} else coul = couleur_ordinateur;
		nb_vide = nb_couleur(a,b,c,0);
		nb_coul = nb_couleur(a,b,c,coul);

		if (nb_coul==3) nb=3; else
		if ((nb_coul==2) && (nb_vide==1)) nb=2; else
		if ((nb_coul==1) && (nb_vide==2)) nb=1;
		return nb;
	}

	public long note()
	{
		int h = 0; int v = 0; int d = 0;
		long note = 0;
		switch (coup) {
			case 0 :
			case 1 :
			case 2 : h = combinaison(0,1,2);break;
			case 3 :
			case 4 :
			case 5 : h = combinaison(3,4,5);break;
			case 6 :
			case 7 :
			case 8 : h = combinaison(6,7,8);break;
		}
		switch (coup) {
			case 0 :
			case 3 :
			case 6 : v = combinaison(0,3,6);break;
			case 1 :
			case 4 :
			case 7 : v = combinaison(1,4,7);break;
			case 2 :
			case 5 :
			case 8 : v = combinaison(2,5,8);break;
		}
		if ((coup==0) || (coup==4) || (coup==8)) d = combinaison(0,4,8);
		if ((coup==2) || (coup==4) || (coup==6)) d = combinaison(2,4,6);
		if (h==1) note += 1;if (v==1) note += 1;if (d==1) note += 1;
		if (h==2) note += 10;if (v==2) note += 10;if (d==2) note += 10;
		if ((h==3) || (v==3) || (d==3)) note = 10000;
		if (coup_ordino) note = 0 - note;
		return (note );
	}

	public long total_note()
	{
		long note = note();
		int i = 0;
		for (i=0;i<coups_possibles.length;i++)
		{
			Damier dam = coups_possibles[i];
			note = note + dam.total_note();
		}
		return note;
	}

	public void cherche_coup()
	{
		if (termine()) return;
		int j = 0;
		for (int i=0;i<9;i++) if (cases[i].code()==0) j++;
		coups_possibles = new Damier[j];
		Damier fils;
		int k=0;
		for (int i=0;i<9;i++)
		{
			if (cases[i].code()==0)
			{
				fils = new Damier(this,i);
				coups_possibles[k]=fils;
				k++;
			}
		}
                if (k != j) System.out.println("diff "+k+"<>"+j);
		for (int i=0;i<coups_possibles.length;i++)
		{
			fils = coups_possibles[i];
			if (fils.niveau<2) fils.cherche_coup();
		}
	}

	public void dessine (Graphics g) {
		int i;
		g.setColor(Color.blue);
		if (couleur_ordinateur==1) g.drawString("Vous jouez avec les RONDS",10,200); else
		g.drawString("Vous jouez avec les CROIX",10,200);
		if (termine()) g.drawString("Le jeu est termin.",10,220);
		else
		{
			if (! coup_ordino) g.drawString("C'est  vous de jouer !",10,220);
			else g.drawString("Je rflchi...",10,220);
		}
		for (i=1;i<3;i++)
		{
			g.drawLine(20+(i*50),20,20+(i*50),170);
			g.drawLine(20,20+(i*50),170,20+(i*50));
		}
		for (i=0;i<9;i++) cases[i].paint(g);
	}

	public void drawat(int x, int y,Graphics g) {
		int i=0;
		g.setColor(Color.black);
		for (i=1;i<3;i++)
		{
			g.drawLine(x+(i*10),y,x+(i*10),y+30);
			g.drawLine(x,y+(i*10),x+30,y+(i*10));
		}
		g.drawString(" "+total_note(),x+35,y+10);
		if (coups_possibles.length>0)
		{
			g.setColor(Color.blue);
			g.drawString(" "+note(),x+35,y+20);
		}
		for (i=0;i<3;i++)
		{
			switch (cases[i].code()) {
			 case 1 :  g.setColor(Color.red);
			 	   g.drawLine(1+x+(i*10),y+1,9+x+(i*10),y+9);
				   g.drawLine(9+x+(i*10),y+1,1+x+(i*10),y+9);
			 	   break;
			 case 2 :  g.setColor(Color.green);g.drawOval(1+x+(i*10),y+1,8,8);
			 break;
			 }
		}
		for (i=3;i<6;i++)
		{
			switch (cases[i].code()) {
			 case 1 :  g.setColor(Color.red);
			 	   g.drawLine(1+x+((i-3)*10),y+11,9+x+((i-3)*10),y+19);
				   g.drawLine(9+x+((i-3)*10),y+11,1+x+((i-3)*10),y+19);
				   break;
			 case 2 :  g.setColor(Color.green);g.drawOval(1+x+((i-3)*10), y+11,8,8);break;
			 }
		}
		for (i=6;i<9;i++)
		{
			switch (cases[i].code()) {
			 case 1 : g.setColor(Color.red);
			 	  g.drawLine(1+x+((i-6)*10),y+21,9+x+((i-6)*10),y+29);
				  g.drawLine(9+x+((i-6)*10),y+21,1+x+((i-6)*10),y+29);
				  break;
			 case 2 : g.setColor(Color.green);g.drawOval( 1+x+((i-6)*10), y+21,8,8);break;
			 }
		}
	}

	public int dessine_minmax (Graphics g, int dep) {
		int position = dep;
		for (int i=0;i<coups_possibles.length;i++)
		{
			Damier d = (Damier)coups_possibles[i];
			d.drawat(niveau*100+2,45+((position)*37),g);
			position = d.dessine_minmax(g,position)+1;
		}
		return position;
	}
}
abstract class Pion {

	int x,y,w,h;
	int num;
	TicTac parent;

	Pion() {x=0;y=0;}
	Pion(int n) {
		num = n+1;
		w=48;h=48;
		if ((num==1) || (num==2) || (num==3))
		{
			y=21;
			x=21+((num-1)*50);
		}
		else
		if ((num==4) || (num==5) || (num==6))
		{
			x=21+((num-4)*50);
			y=71;
		}
		else
		{
			x=21+((num-7)*50);
			y=121;
		}

	}
	public void paint (Graphics g){}
	public boolean coup(int x1, int y1){ return false;}
	public int code (){ return 0; }
}

class Croix extends Pion {


	Croix (int n,TicTac p){super(n); parent = p;}
	public void paint (Graphics g){
	g.setColor(Color.red);
	g.drawLine( x, y,x+w,y+h);
	g.drawLine( x+w, y,x,y+w);
//	g.drawImage(img,x,y,w,h,parent);
	}
	public int code (){ return 1; }
}

class Rond extends Pion {

	Rond (int n, TicTac p){super(n);parent = p;}
	public void paint (Graphics g){
	g.setColor(Color.green);
	g.drawOval( x, y,w,h);
//	g.drawImage(img,x,y,w,h,parent);
	}
	public int code (){ return 2; }
}

class Vide extends Pion {

	Vide (int n){super(n);}
	public void paint (Graphics g){
	g.clearRect( x, y,w,h);}
	public boolean coup(int x1, int y1)
	{
		boolean ok = false;
		if ((x1>x) && (x1<x+w) && (y1>y) && (y1<y+h)) ok = true;
		return ok;
	}
}
